{
Cet exemple vous montre comment modifier un Menu d'une autre application,
depuis un programme Delphi.
Attention: les Menus ne fonctionnent pas comme des composants normaux

Pour infos supplmentaires, me mailer : sephirothlune@ifrance.com
ou regarder l'aide WIN32.HLP (normalement situe ici:
"C:\Program Files\Fichiers communs\Borland Shared\MSHelp\WIN32.HLP")

Par Sephiroth Lune, pour www.phidels.com
}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Menus;

type
  TForm1 = class(TForm)
    Button2: TButton;
    Button4: TButton;
    MainMenu1: TMainMenu;
    Fichiers1: TMenuItem;
    Item11: TMenuItem;
    Item21: TMenuItem;
    Options1: TMenuItem;
    Item12: TMenuItem;
    Item22: TMenuItem;
    Aide1: TMenuItem;
    Item13: TMenuItem;
    Item31: TMenuItem;
    Label1: TLabel;
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// Delete un menu --------------------------------------------------------------

procedure TForm1.Button2Click(Sender: TObject);
var Hwnd: THandle;
    Hwnd2:HMenu;
begin
  // recherche le handle de l'application (Pour agir sur une autre application,
  // remplacer 'Tuto menus' par le Caption de la barre de titre de la fentre de
  // l'application sur laquelle vous voulez agir).
  Hwnd:=FindWindow(nil, 'Tuto menus');
  // recherche handle du menu
  Hwnd2:=GetMenu(Hwnd);
  // on supprime le menu '0' (le premier)
  // MF_BYPOSITION car on veut que le 0 soit relatif a la position des menus
  // MF_BYCOMMAND si on veut que le 0 soit l'ID du menu (diffrent du handle attention)
  // ATTENTION: quelques problmes de rafrachissement peuvent apparaitre
  // si vous le faite sur l'application qui demande le changement de menu
  // mais normalement, sur une autre application, ce problme disparait
  DeleteMenu(Hwnd2, 0, MF_BYPOSITION);
end;

// Change un sous-menu ---------------------------------------------------------

procedure TForm1.Button4Click(Sender: TObject);
// ATTENTION: si vous essayez de modifier le menu 
// du programme qui demande ce changement, ceci risque de ne pas fonctionner 
// maintenant je ne peux pas dire pourquoi...
var MenuItemInfo : TMenuItemInfo;
    Hwnd:THandle;
    Hwnd2, Hwnd3:HMenu;
begin
// recherche du handle de l'application
// parametres:
// 1) type de l'application (peut etre nil si on le connais pas)
// 2) nom de l'appication (peut etre nil si on dispose du type, mais il doit etre unique
// sinon le handle renvoy sera le premier trouv

// ATTENTION REMPLACER, dans la ligne de code  suivante
// 'Caption du programme' par ce qui est crit comme caption dans
// la barre de titre de votre fentre principale. Par exemple, si vous voulez tester
// sur le bloc note : remplacer le par 'Sans titre - Bloc-notes' (enfin vrifiez que c'est ce qui est
// crit dans le caption de la fentre du bloc note...);
Hwnd:=FindWindow(nil, 'Caption du programme');
// recherche handle du menu
Hwnd2:=GetMenu(Hwnd);
// recherche handle du sous-menus du menu '1' (donc le 2eme car on part de 0)
Hwnd3:=GetSubMenu(Hwnd2, 1);
Button2.Caption:=IntToStr(Hwnd3);

FillChar(MenuItemInfo,SizeOf(TMenuItemInfo), #0);
// on definit la taille du menu
MenuItemInfo.cbSize := SizeOf(TMenuItemInfo);
// on definit ici quelques proprits
MenuItemInfo.fMask := MIIM_TYPE or MIIM_ID or MIIM_STATE;
// on dit que l'item  changer sera de type STRING (chaine ce caractere)
MenuItemInfo.fType := MFT_STRING;

// on definit le caption du sous-menu  changer
MenuItemInfo.dwTypeData := 'Item chang';
// on definit la taille du caption
MenuItemInfo.cch := Length('Item chang');

// exemple pour mettre un menu qui n'est pas clickable a clickable
MenuItemInfo.fState:=MFS_ENABLED;

// on applique enfin toutes les modifications
SetMenuItemInfo(hwnd3, 0, TRUE, MenuItemInfo);
end;

end.
